#include "fpsclass.h"


FpsClass::FpsClass()
{
}


FpsClass::FpsClass(const FpsClass& other)
{
}


FpsClass::~FpsClass()
{
}

void FpsClass::Initialize()
{
    m_fps = 0;
    m_count = 0;
    m_minFps = INT_MAX;
    m_maxFps = 0;
    m_frameTime = 0.0f;
    m_previousTime = timeGetTime();
    m_startTime = m_previousTime;

    return;
}

void FpsClass::Frame()
{

    unsigned int currentTime = timeGetTime();

    m_frameTime = (currentTime - m_previousTime) * 0.001f;
    m_previousTime = currentTime;
    
    m_count++;

    if (timeGetTime() >= (m_startTime + 1000))
    {
        m_fps = m_count;

        if (m_fps < m_minFps)
            m_minFps = m_fps;

        if (m_fps > m_maxFps)
            m_maxFps = m_fps;
        
        m_count = 0;
        m_startTime = timeGetTime();
    }

    return;
}

int FpsClass::GetMinFps() const
{
    return m_minFps;
}

int FpsClass::GetMaxFps() const
{
    return m_maxFps;
}

float FpsClass::GetFrameTime() const
{
    return m_frameTime;
}

void FpsClass::ResetStats()
{
    m_minFps = INT_MAX;
    m_maxFps = 0;
}

int FpsClass::GetFps()
{
    return m_fps;
}